package cn.com.ctop.okr.controller;

import cn.com.ctop.okr.entity.OkrTaskInfoDisclosure;
import cn.com.ctop.okr.service.IOkrTaskInfoDisclosureService;
import cn.com.ctop.okr.vo.Result;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Arrays;

 /**
 * okr o 信息公开
 * @author jeecg-boot
 * @date   2020-09-04
 * @version V1.0
 */
@Slf4j
@RestController
@RequestMapping("/ctop/okrTaskInfoDisclosure")
public class OkrTaskInfoDisclosureController {
	@Autowired
	private IOkrTaskInfoDisclosureService OkrTaskInfoDisclosureService;

	/**
	  * 分页列表查询
	 * @param OkrTaskInfoDisclosure
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<OkrTaskInfoDisclosure>> queryPageList(OkrTaskInfoDisclosure OkrTaskInfoDisclosure,
															  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
															  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
															  HttpServletRequest req) {
		Result<IPage<OkrTaskInfoDisclosure>> result = new Result<>();
		QueryWrapper<OkrTaskInfoDisclosure> queryWrapper = new QueryWrapper<>();
		Page<OkrTaskInfoDisclosure> page = new Page<>(pageNo, pageSize);
		IPage<OkrTaskInfoDisclosure> pageList = OkrTaskInfoDisclosureService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}

	/**
	  *   添加
	 * @param OkrTaskInfoDisclosure
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<OkrTaskInfoDisclosure> add(@RequestBody OkrTaskInfoDisclosure OkrTaskInfoDisclosure) {
		Result<OkrTaskInfoDisclosure> result = new Result<>();
		try {
			OkrTaskInfoDisclosureService.save(OkrTaskInfoDisclosure);
			result.success("添加成功！");
		} catch (Exception e) {
			log.error(e.getMessage(),e);
			result.error500("操作失败");
		}
		return result;
	}

	/**
	  *  编辑
	 * @param OkrTaskInfoDisclosure
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<OkrTaskInfoDisclosure> edit(@RequestBody OkrTaskInfoDisclosure OkrTaskInfoDisclosure) {
		Result<OkrTaskInfoDisclosure> result = new Result<OkrTaskInfoDisclosure>();
		OkrTaskInfoDisclosure OkrTaskInfoDisclosureEntity = OkrTaskInfoDisclosureService.getById(OkrTaskInfoDisclosure.getId());
		if(OkrTaskInfoDisclosureEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = OkrTaskInfoDisclosureService.updateById(OkrTaskInfoDisclosure);
			if(ok) {
				result.success("修改成功!");
			}
		}

		return result;
	}

	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<?> delete(@RequestParam(name="id",required=true) String id) {
		try {
			OkrTaskInfoDisclosureService.removeById(id);
		} catch (Exception e) {
			log.error("删除失败",e.getMessage());
			return Result.error("删除失败!");
		}
		return Result.ok("删除成功!");
	}

	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<OkrTaskInfoDisclosure> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<OkrTaskInfoDisclosure> result = new Result<>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.OkrTaskInfoDisclosureService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}

	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<OkrTaskInfoDisclosure> queryById(@RequestParam(name="id",required=true) String id) {
		Result<OkrTaskInfoDisclosure> result = new Result<>();
		OkrTaskInfoDisclosure OkrTaskInfoDisclosure = OkrTaskInfoDisclosureService.getById(id);
		if(OkrTaskInfoDisclosure==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(OkrTaskInfoDisclosure);
			result.setSuccess(true);
		}
		return result;
	}
}
