package cn.com.ctop.okr.controller;

import cn.com.ctop.okr.dto.TagInfoTreeModel;
import cn.com.ctop.okr.service.QYWxDepartInfoService;
import cn.com.ctop.okr.vo.Result;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.SecurityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("department")
@Slf4j
public class WechatDepartmentController {
    @Autowired
    private QYWxDepartInfoService qyWxDepartInfoService;
    @RequestMapping(value = "/queryTreeList", method = RequestMethod.GET)
    public Result<List<TagInfoTreeModel>> queryTreeList() {
        Result<List<TagInfoTreeModel>> result = new Result<>();
        try {
            List<TagInfoTreeModel> list = qyWxDepartInfoService.queryTreeList();
            result.setResult(list);
            result.setSuccess(true);
        } catch (Exception e) {
            log.error(e.getMessage(),e);
        }
        return result;
    }
}
