package cn.com.ctop.okr.dto;

import cn.com.ctop.okr.entity.QYWxDepartInfo;
import cn.com.ctop.okr.entity.QYWxUserInfo;
import lombok.Data;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@Data
public class TagIdModel implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     * 主键ID
     */
    private String id;

    /**
     * 主键ID
     */
    private String value;

    /**
     * 部门名称
     */
    private String label;

    List<TagIdModel> children = new ArrayList<>();

    /**
     * 将SysDepartTreeModel的部分数据放在该对象当中
     * @param treeModel 树状结构
     * @return 部门信息
     */
    public TagIdModel convert(TagInfoTreeModel treeModel) {
        this.id = treeModel.getId()+"";
        this.value = treeModel.getId()+"";
        this.label = treeModel.getLabel();
        return this;
    }

    public TagIdModel convertByUserDepart(QYWxUserInfo userInfo) {
        this.id = userInfo.getUserid();
        this.value = userInfo.getUserid();
        this.label = userInfo.getName();
        return this;
    }

    public TagIdModel convertByUserDepart(QYWxDepartInfo departInfo) {
        this.id = departInfo.getId()+"";
        this.value = departInfo.getId()+"";
        this.label = departInfo.getDepartName();
        return this;
    }
}
