package cn.com.ctop.okr.service;

import cn.com.ctop.okr.dto.OkrDto;
import cn.com.ctop.okr.dto.UserInfoDto;
import cn.com.ctop.okr.entity.OkrContentStatus;
import cn.com.ctop.okr.entity.OkrKrInfo;
import cn.com.ctop.okr.entity.OkrObjectInfo;
import cn.com.ctop.okr.entity.OkrTaskInfo;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;

import java.util.List;
import java.util.Map;

public interface OkrService{

    Map<String, Object> getOkrInfo(UserInfoDto data);

    void insertOkrMember(List<String> memberList);

    void deleteOkrMember(String memberId);

    void insertOkrMember2(List<String> memberList);

    List<UserInfoDto> getMemberListByUserId(String name);

    Map<String, Object> getSyncUserListByMemberId(JSONObject data);

    void insertTaskInfo(OkrTaskInfo taskInfo);

    void updateTaskInfo(OkrTaskInfo taskInfo);

    void insertContentStatus(OkrContentStatus content);

    void updateContentStatus(OkrContentStatus content);

    void insertObjectAndKrList(OkrObjectInfo objectInfo, List<OkrKrInfo> krList);

    void updateObject(OkrObjectInfo objectInfo);

    void updateKr(OkrKrInfo okrKrInfo);

    void deleteObjectInfoById(OkrObjectInfo objectInfo);

    void deleteKrById(OkrKrInfo krInfo);

    void deleteContentStatusById(OkrContentStatus content);

    void deleteTaskInfoById(OkrTaskInfo okrTaskInfo);

    void keepTaskInfoById(OkrTaskInfo okrTaskInfo);

    void insertOkrKrInfo(OkrKrInfo krInfo);

    List<Integer> getObjectYear();

    Map<String, Object> getMyFollowList(JSONObject data);

    Map<String, Object> getMyDepartmentList(JSONObject data);

    Map<String, Object> getOkrDetail(JSONObject data);

}
