package cn.com.ctop.okr.service.impl;

import cn.com.ctop.okr.entity.OkrObjectInfo;
import cn.com.ctop.okr.mapper.OkrObjectInfoMapper;
import cn.com.ctop.okr.service.IOkrObjectInfoService;
import cn.com.ctop.okr.utils.DateUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Service
public class OkrObjectInfoServiceImpl extends ServiceImpl<OkrObjectInfoMapper, OkrObjectInfo> implements IOkrObjectInfoService {
    @Autowired
    private OkrObjectInfoMapper objectInfoMapper;
    @Override
    public OkrObjectInfo getByParams(String userId, Integer year, Integer quarter) {
        QueryWrapper<OkrObjectInfo>queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("user_id",userId).eq("year",year).eq("quarter",quarter);
        queryWrapper.orderByDesc("create_time").last("limit 1");
        return this.getOne(queryWrapper);
    }

    @Override
    public List<OkrObjectInfo> getQuarterObject(String userId, Integer year, Integer quarter) {
        return objectInfoMapper.getQuarterObject(userId,year,quarter);
    }

    @Override
    public void insertObjectInfo(OkrObjectInfo objectInfo,String userId,Integer year,Integer quarter) {
        objectInfo.setQuarter(quarter);
        objectInfo.setYear(year);
        objectInfo.setUserId(userId);
        objectInfoMapper.insertObjectInfo(objectInfo);
    }

    @Override
    public void updateObjectInfo(OkrObjectInfo objectInfo) {
        objectInfoMapper.updateObjectInfo(objectInfo);
    }

    @Override
    public List<OkrObjectInfo> getAllQuarterObject(String name, Integer year, Integer quarter, int startIndex, Integer pageSize) {
        return objectInfoMapper.getAllQuarterObject(name,year,quarter,startIndex,pageSize);
    }

    @Override
    public List<OkrObjectInfo> getFollowQuarterObject(String userId,String name, Integer year, Integer quarter, int startIndex, Integer pageSize) {
        return objectInfoMapper.getFollowQuarterObject(userId,name,year,quarter,startIndex,pageSize);
    }

    @Override
    public List<OkrObjectInfo> getDepartmentQuarterObject(String openId, String name, Integer year, Integer quarter, int startIndex, Integer pageSize) {
        return objectInfoMapper.getDepartmentQuarterObject(openId,name,year,quarter,startIndex,pageSize);
    }

    @Override
    public void deleteObjectInfoById(OkrObjectInfo objectInfo) {
        objectInfoMapper.deleteObjectInfoById(objectInfo);
    }

    @Override
    public List<Integer> getObjectYear() {
        List<Integer>years = new ArrayList<>();
        int  year = DateUtils.getYear(new Date());
        years.add(year-1);
        years.add(year);
        years.add(year+1);
        return years;
    }
}
