package cn.com.ctop.okr.service.impl;

import cn.com.ctop.okr.entity.OkrWeekData;
import cn.com.ctop.okr.mapper.OkrWeekDataMapper;
import cn.com.ctop.okr.service.IOkrWeekDataService;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class OkrWeekDataServiceImpl extends ServiceImpl<OkrWeekDataMapper, OkrWeekData> implements IOkrWeekDataService {
    @Override
    public OkrWeekData getWeekByDate(String now) {
        QueryWrapper<OkrWeekData>queryWrapper = new QueryWrapper<>();
        queryWrapper.le("start_Date",now).ge("end_date",now).last("limit 1");
        return this.getOne(queryWrapper);
    }

    @Override
    public Map<Integer, Object> getWeeksByMonths(Integer year,List<Integer> months) {
        Map<Integer,Object> result = new HashMap<>();
        if(null == months||months.isEmpty()){
            return result;
        }
        for(int i=0;i<months.size();i++){
            List<OkrWeekData>dataList = this.getWeekByYearAndMonth(year,months.get(i));
            JSONArray getWeek = new JSONArray();
            for(OkrWeekData data:dataList){
                JSONObject weekObject = new JSONObject();
                weekObject.put("week",data.getWeek());
                weekObject.put("startDate",data.getStartDate());
                weekObject.put("endDate",data.getEndDate());
                getWeek.add(weekObject);
            }
            result.put(months.get(i),getWeek);
        }
        return result;
    }

    @Override
    public OkrWeekData getWeekByYearAndWeek(Integer year, int week) {
        QueryWrapper<OkrWeekData>queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("year",year).ge("week",week).last("limit 1");
        return this.getOne(queryWrapper);
    }

    private List<OkrWeekData> getWeekByYearAndMonth(Integer year, Integer month) {
        QueryWrapper<OkrWeekData>queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("year",year).eq("month",month).orderByAsc("week");
        return this.list(queryWrapper);
    }
}
