package cn.com.ctop.okr.service.impl;

import cn.com.ctop.okr.dto.TagIdModel;
import cn.com.ctop.okr.dto.TagInfoTreeModel;
import cn.com.ctop.okr.entity.QYWxDepartInfo;
import cn.com.ctop.okr.mapper.QYWxDepartInfoMapper;
import cn.com.ctop.okr.mapper.QYWxUserInfoMapper;
import cn.com.ctop.okr.service.QYWxDepartInfoService;
import cn.com.ctop.okr.utils.oConvertUtils;
import cn.com.ctop.okr.vo.QYWxDepartInfoVO;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class QYWxDepartInfoServiceImpl extends ServiceImpl<QYWxDepartInfoMapper, QYWxDepartInfo> implements QYWxDepartInfoService {
    @Autowired
    private QYWxDepartInfoMapper qyWxDepartInfoMapper;
    @Autowired
    private QYWxUserInfoMapper qyWxUserInfoMapper;
    @Override
    public List<TagInfoTreeModel> queryTreeList() {
        List<QYWxDepartInfoVO> all = new ArrayList<>();
        QYWxDepartInfoVO vo = new QYWxDepartInfoVO();
        vo.setId("10086");
        vo.setValue("10086");
        vo.setLabel("所有人");
        vo.setParentId(1L);
        all.add(vo);
        List<QYWxDepartInfoVO> list = qyWxDepartInfoMapper.getDepartInfoVo();
        all.addAll(list);
        List<QYWxDepartInfoVO> userList = qyWxUserInfoMapper.getDepartInfoVo();
        all.addAll(userList);
        // 调用wrapTreeDataToTreeList方法生成树状数据
        return this.wrapTreeDataToTreeList(all);
    }

    /**
     * queryTreeList的子方法 ====1=====
     * 该方法是s将SysDepart类型的list集合转换成SysDepartTreeModel类型的集合
     */
    public List<TagInfoTreeModel> wrapTreeDataToTreeList(List<QYWxDepartInfoVO> recordList) {
        // 在该方法每请求一次,都要对全局list集合进行一次清理
        //idList.clear();
        List<TagIdModel> idList = new ArrayList<>();
        List<TagInfoTreeModel> records = new ArrayList<>();
        for (int i = 0; i < recordList.size(); i++) {
            QYWxDepartInfoVO depart = recordList.get(i);
            records.add(new TagInfoTreeModel(depart));
        }
        List<TagInfoTreeModel> tree = findChildren(records, idList);
        setEmptyChildrenAsNull(tree);
        return tree;
    }

    /**
     * 获取 DepartIdModel
     * @param recordList
     * @return
     */
    public List<TagIdModel> wrapTreeDataToDepartIdTreeList(List<QYWxDepartInfoVO> recordList) {
        // 在该方法每请求一次,都要对全局list集合进行一次清理
        //idList.clear();
        List<TagIdModel> idList = new ArrayList<TagIdModel>();
        List<TagInfoTreeModel> records = new ArrayList<>();
        for (int i = 0; i < recordList.size(); i++) {
            QYWxDepartInfoVO depart = recordList.get(i);
            records.add(new TagInfoTreeModel(depart));
        }
        findChildren(records, idList);
        return idList;
    }

    /**
     * queryTreeList的子方法 ====2=====
     * 该方法是找到并封装顶级父类的节点到TreeList集合
     */
    private List<TagInfoTreeModel> findChildren(List<TagInfoTreeModel> recordList, List<TagIdModel> departIdList) {

        List<TagInfoTreeModel> treeList = new ArrayList<>();
        for (int i = 0; i < recordList.size(); i++) {
            TagInfoTreeModel branch = recordList.get(i);
            if (oConvertUtils.isEmpty(branch.getParentId())||branch.getParentId().equals("0")) {
                treeList.add(branch);
                TagIdModel departIdModel = new TagIdModel().convert(branch);
                departIdList.add(departIdModel);
            }
        }
        getGrandChildren(treeList,recordList,departIdList);

        //idList = departIdList;
        return treeList;
    }

    /**
     * queryTreeList的子方法====3====
     *该方法是找到顶级父类下的所有子节点集合并封装到TreeList集合
     */
    private void getGrandChildren(List<TagInfoTreeModel> treeList,List<TagInfoTreeModel> recordList,List<TagIdModel> idList) {

        for (int i = 0; i < treeList.size(); i++) {
            TagInfoTreeModel model = treeList.get(i);
            TagIdModel idModel = idList.get(i);
            for (int i1 = 0; i1 < recordList.size(); i1++) {
                TagInfoTreeModel m = recordList.get(i1);
                if (m.getParentId()!=null && m.getParentId().equals(model.getId())) {
                    model.getChildren().add(m);
                    TagIdModel dim = new TagIdModel().convert(m);
                    idModel.getChildren().add(dim);
                }
            }
            getGrandChildren(treeList.get(i).getChildren(), recordList, idList.get(i).getChildren());
        }

    }


    /**
     * queryTreeList的子方法 ====4====
     * 该方法是将子节点为空的List集合设置为Null值
     */
    private void setEmptyChildrenAsNull(List<TagInfoTreeModel> treeList) {

        for (int i = 0; i < treeList.size(); i++) {
            TagInfoTreeModel model = treeList.get(i);
            if (null == model.getChildren()||model.getChildren().isEmpty()) {
                model.setChildren(null);
                model.setLeaf(true);
            }else{
                setEmptyChildrenAsNull(model.getChildren());
                model.setLeaf(false);
            }
        }
        // sysDepartTreeList = treeList;
    }

    @Override
    public List<String>getUserIdByDepartId(Long departId){
        return qyWxDepartInfoMapper.getUserIdByDepartId(departId);
    }

    @Override
    public List<String> getAllUserId() {
        return qyWxDepartInfoMapper.getAllUserId();
    }
}
