package cn.com.ctop.okr.vo;

import cn.com.ctop.okr.dto.TagInfoTreeModel;
import cn.com.ctop.okr.entity.QYWxDepartInfo;
import cn.com.ctop.okr.entity.QYWxUserInfo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class QYWxDepartInfoVO implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     *对应TagInfo中的id字段,前端数据树中的key
     */
    private String id;

    /**
     *对应TagInfo中的id字段,前端数据树中的value
     */
    private String value;

    /**
     *对应name字段,前端数据树中的title
     */
    private String label;

    /**
     * 以下所有字段均与TagInfo相同
     */
    private boolean isLeaf;
    private Long parentId;

    private List<TagInfoTreeModel> children = new ArrayList<>();

    /**
     * 将SysDepart对象转换成SysDepartTreeModel对象
     * @param departInfo
     */
    public QYWxDepartInfoVO(QYWxDepartInfo departInfo) {
        this.id = departInfo.getId()+"";
        this.value = departInfo.getId()+"";
        this.label = departInfo.getDepartName();
    }
    public QYWxDepartInfoVO(QYWxUserInfo departInfo) {
        this.id = departInfo.getUserid();
        this.value = departInfo.getUserid();
        this.label = departInfo.getName();
    }



    public List<TagInfoTreeModel> getChildren() {
        return children;
    }

    public void setChildren(List<TagInfoTreeModel> children) {
        if (children==null){
            this.isLeaf=true;
        }
        this.children = children;
    }

    public QYWxDepartInfoVO() {

    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public boolean isLeaf() {
        return isLeaf;
    }

    public void setLeaf(boolean leaf) {
        isLeaf = leaf;
    }

    public Long getParentId() {
        return parentId;
    }

    public void setParentId(Long parentId) {
        this.parentId = parentId;
    }
}
